local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

local GetTime = GetTime

local lastPanel;
local sName = L["Reincarnation"]
local _hex
local red = "|cffb11919"
local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', GetSpellTexture(20608))

--if E.myclass ~= "Shaman" then return end
local function OnUpdate(self)
	local s, d = GetSpellCooldown(sName)
	if s > 0 and d > 0 then 
		self.text:SetFormattedText(texture.." "..red..format("%d:%02d", floor((d-(GetTime()-s))/60), floor((d-(GetTime()-s))%60)).."|r")
	else
		self.text:SetFormattedText(texture.." ".._hex..L["Ready"].."!|r")
	end
end

local function OnEvent(self, event, timerType, timeSeconds, totalTime)
	local isKnown = IsSpellKnown(20608, false)
	if (not isKnown) then
		self.text:SetFormattedText(_hex..sName.."|r "..L["Not learned!"])
	else
		if(event == "SPELL_UPDATE_COOLDOWN") then
			self:SetScript("OnUpdate", OnUpdate)
		elseif(not self.text:GetText()) then
			local s, d = GetSpellCooldown(sName)
			if s > 0 and d > 0 then 
				self.text:SetFormattedText(texture.." "..red..format("%d:%02d", floor((d-(GetTime()-s))/60), floor((d-(GetTime()-s))%60)).."|r")
			else
				self.text:SetFormattedText(texture.." ".._hex..L["Ready"].."!|r")
			end
		end
	end
	lastPanel = self
end

local function OnEnter(self)
	if not InCombatLockdown() then
		local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b
		DT:SetupTooltip(self)
		DT.tooltip:AddDoubleLine(L["Click"], L["Report cooldown to party/raid"], r1, g1, b1, r2, g2, b2)
		DT.tooltip:Show()
	end
	if lastPanel ~= nil then OnEvent(lastPanel) end
end

local function OnClick(self)
	local inInstance, instanceType = IsInInstance()
	local s, d = GetSpellCooldown(sName)
	local message = L["Reincarnation"]..": "..format("%d:%02d", floor((d-(GetTime()-s))/60), floor((d-(GetTime()-s))%60)).." "..L["remaining"].."!";

	if s > 0 and d > 0 then 
		if instanceType == "raid" then
			SendChatMessage(message , "RAID", nil, nil)
		elseif instanceType == "party" then
			SendChatMessage(message , "PARTY", nil, nil)
		end
	end
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then OnEvent(lastPanel) end
end
E["valueColorUpdateFuncs"][ValueColorUpdate] = true

DT:RegisterDatatext("Reincarnation", {"PLAYER_ENTERING_WORLD", "SPELL_UPDATE_COOLDOWN"}, OnEvent, OnUpdate, OnClick, OnEnter)

